# S2MLCore version 1.0.0
# S2MLType.py
# by Antoine Rauzy
# Copyrights (c) 2018 AltaRica Association
#
# This file is part of S2MLCore.
# S2MLCore is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# S2MLCore is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with S2MLCore.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) S2MLType
#   2.1) Tokens & keywords
#   2.2) S2ML elements
#   2.3) Stochastic expressions

# 1) Imported modules
# -------------------

# 2) S2MLType
# -----------

class S2MLType:

# 2.1) Tokens & keywords
# ----------------------

  # Generic tokens
  TOKEN_NUMBER = 1
  TOKEN_IDENTIFIER = 2
  TOKEN_PATH = 3
  TOKEN_COMMENT = 4
  TOKEN_NON_TERMINATED_COMMENT = 5
  TOKEN_UNKNOWN = 6

  # Symbols
  TOKEN_LPAR = 101
  TOKEN_RPAR = 102
  TOKEN_LBRACE = 103
  TOKEN_RBRACE = 104
  TOKEN_SEMICOLON = 105
  TOKEN_COMMA = 106
  TOKEN_COLON = 107
  TOKEN_EQUAL = 108

  # Keywords for S2ML constructs
  KEYWORD_DOMAIN = 201
  KEYWORD_BLOCK = 202
  KEYWORD_CLASS = 203
  KEYWORD_END = 204
  KEYWORD_CLONES = 205
  KEYWORD_AS = 206
  KEYWORD_EMBEDS = 207
  KEYWORD_EXTENDS = 208
  KEYWORD_PARAMETER = 220

  # Keywords for stochastic expressions
  KEYWORD_ADD = 311
  KEYWORD_SUB = 312
  KEYWORD_MUL = 313
  KEYWORD_DIV = 314
  KEYWORD_NEG = 315
  KEYWORD_MIN = 316
  KEYWORD_MAX = 317
  KEYWORD_FALSE = 321
  KEYWORD_TRUE = 322
  KEYWORD_AND = 323
  KEYWORD_OR  = 324
  KEYWORD_NOT = 325
  KEYWORD_EQ  = 331
  KEYWORD_DF  = 332
  KEYWORD_LT  = 333
  KEYWORD_GT  = 334
  KEYWORD_LEQ = 335
  KEYWORD_GEQ = 336
  KEYWORD_COUNT = 341
  KEYWORD_IF = 342

# 2.2) S2ML elements
# ------------------

  UNKNOWN = 0

  DOMAIN = 201
  BLOCK = 202
  CLASS = 203
  CLONES = 205
  EMBEDS = 207
  EXTENDS = 208
  INSTANCE = 209
  MODEL = 210
  PORT = 211
  PARAMETER = 220

# 2.3) Stochastic expressions
# ---------------------------

  REFERENCE_EXPRESSION = 301
  CONSTANT_EXPRESSION = 302
  ADD_EXPRESSION = 311
  SUB_EXPRESSION = 312
  MUL_EXPRESSION = 313
  DIV_EXPRESSION = 314
  NEG_EXPRESSION = 315
  MIN_EXPRESSION = 316
  MAX_EXPRESSION = 317
  AND_EXPRESSION = 323
  OR_EXPRESSION  = 324
  NOT_EXPRESSION = 325
  EQ_EXPRESSION  = 331
  DF_EXPRESSION  = 332
  LT_EXPRESSION  = 333
  GT_EXPRESSION  = 334
  LEQ_EXPRESSION = 335
  GEQ_EXPRESSION = 336
  COUNT_EXPRESSION = 341
  IF_EXPRESSION = 342
